using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline;
using Microsoft.Xna.Framework.Content.Pipeline.Graphics;
using Microsoft.Xna.Framework.Content.Pipeline.Processors;

// TODO: replace these with the processor input and output types.
using TInput = System.String;
using TOutput = System.String;

namespace ModelWithTangentPipeline
{
    /// <summary>
    /// http://msdn.microsoft.com/en-us/library/bb447748.aspx
    /// </summary>
    [ContentProcessor]
    class ModelProcessorWithTangents : ModelProcessor
    {
        public override ModelContent Process(NodeContent input, ContentProcessorContext context)
        {
            GenerateTangentFramesRecursive(input);
            return base.Process(input, context);
        }

        private void GenerateTangentFramesRecursive(NodeContent node)
        {
            MeshContent mesh = node as MeshContent;
            if (mesh != null)
            {
                MeshHelper.CalculateTangentFrames(mesh, VertexChannelNames.TextureCoordinate(0), VertexChannelNames.Tangent(0), VertexChannelNames.Binormal(0));
            }

            foreach (NodeContent child in node.Children)
            {
                GenerateTangentFramesRecursive(child);
            }
        }
    }
}