﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace XNATutorial.Entity
{
    public interface IDrawableEntity
    {
        /// <summary>
        /// Get / Set the Effect for drawing the object.
        /// </summary>
        IEffectMatrices Effect { get; set; }

        /// <summary>
        /// Draw entity on screen in relation to the view- and projection matrix.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        /// <param name="view">The view matrix.</param>
        /// <param name="projection">The projection matrix.</param>
        void Draw(GameTime gameTime, Matrix view, Matrix projection);
    }
}
